﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
namespace WinApp
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }
    
        // Создаем объект Web-службы 
        WinApp.localhost1.Service calcWebService = 
            new WinApp.localhost1.Service();

        double numResult;
        private void btnClick(object sender, EventArgs e)
        {
            double numFirst, numSecond;
    
            // Копируем текстовые поля в локальные переменные
            string strFirst = string.Copy(txtFirst.Text);
            string strSecond = string.Copy(txtSecond.Text);
    
            // Замена в строке точки символом запятой
            // для корректного преобразования в число
            int pos = strFirst.IndexOf('.');
            if (pos != -1)
            {
                strFirst = strFirst.Substring(0, pos)
                    + ','
                    + strFirst.Substring(pos + 1);
            }
            pos = strSecond.IndexOf('.');
            if (pos != -1)
            {
                strSecond = strSecond.Substring(0, pos)
                    + ','
                    + strSecond.Substring(pos + 1);
            }
    
            // Преобразуем текст в число для выполнения операций
            if (txtFirst.Text.Length > 0)
                numFirst = Convert.ToDouble(strFirst);
            else
                numFirst = 0.0D;
            if (txtSecond.Text.Length > 0)
                numSecond = Convert.ToDouble(strSecond);
            else
                numSecond = 0.0D;
    
            // Выполняем нужную операцию
            Button btn = (Button)sender;// Явное приведение типов для распознавания кнопок
            switch (btn.Name)// Переключатель
            {
                case "btnAdd":// Операция сложения
                    numResult = calcWebService.Add(numFirst, numSecond);
                    break;
                case "btnSubtract":// Операция вычитания
                    numResult = calcWebService.Subtract(numFirst, numSecond);
                    break;
                case "btnMultiply":// Операция умножения
                    numResult = calcWebService.Multiply(numFirst, numSecond);
                    break;
                case "btnDivide":// Операция деления
                    // Корректность деления проверяется Web-службой 
                    numResult = calcWebService.Divide(numFirst, numSecond);
                    break;
            }
    
            // Печатаем результат
            txtResult.Text = Convert.ToString(numResult);
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private bool isNumber = false;

        private void txtFirst_KeyDown(object sender, KeyEventArgs e)
        {
            isNumber =
                e.KeyCode >= Keys.D0 && e.KeyCode <= Keys.D9 // keyboard - основная клавиатура
                || e.KeyCode >= Keys.NumPad0 && e.KeyCode <= Keys.NumPad9 // keypad - дополнительная клавиатура
                || e.KeyCode == Keys.Back;
        }

        private void txtFirst_KeyPress(object sender, KeyPressEventArgs e)
        {
            TextBox box = (TextBox)sender;// Явное преобразование типов

            switch (e.KeyChar) // Переключатель
            {
                case '-': // Разрешаем минус, если он первый
                    if (box.Text.Length == 0)
                        isNumber = true;
                    break;
                case '.':
                    // Точка не должна быть первой
                    if (box.Text.Length == 0)
                        break;
                    // Точка не должна следовать сразу за минусом
                    if (box.Text[0] == '-' && box.Text.Length == 1)
                        break;
                    // Точка должна быть одна
                    if (box.Text.IndexOf('.') == -1)
                        isNumber = true; // Еще не было точек
                    break;
            }

            // Запрещаем в текстовом поле лишние символы
            if (!isNumber)
                e.Handled = true;
        }
    }
}